psdir = @psdir@
INST_TARGETS = @INST_TARGETS@
-SUBDIRS = ffi imail ref-manual sos user-manual
+SUBDIRS = ffi ref-manual sos user-manual
DISTCLEAN_FILES = Makefile make-common config.log config.status
all:
Makefile
make-common
ffi/Makefile
- imail/Makefile
ref-manual/Makefile
sos/Makefile
user-manual/Makefile])
+++ /dev/null
-
-# Copyright (C) 1986, 1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994,
-# 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004,
-# 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014,
-# 2015, 2016 Massachusetts Institute of Technology
-#
-# This file is part of MIT/GNU Scheme.
-#
-# MIT/GNU Scheme is free software; you can redistribute it and/or
-# modify it under the terms of the GNU General Public License as
-# published by the Free Software Foundation; either version 2 of the
-# License, or (at your option) any later version.
-#
-# MIT/GNU Scheme is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
-# General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with MIT/GNU Scheme; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
-# 02110-1301, USA.
-
-@SET_MAKE@
-srcdir = @srcdir@
-top_srcdir = @top_srcdir@
-VPATH = @srcdir@
-
-TARGET_ROOT = mit-scheme-imail
-TEXINFO_ROOT = imail
-SOURCES = $(TEXINFO_ROOT).texinfo
-
-include $(top_srcdir)/make-common
<li><a href="mit-scheme-user/index.html">User's Manual</a></li>
<li><a href="mit-scheme-ref/index.html">Reference Manual</a></li>
<li><a href="mit-scheme-sos/index.html">Scheme Object System</a></li>
-<li><a href="mit-scheme-imail/index.html">IMAP/MIME email reader</a></li>
<li><a href="mit-scheme-ffi/index.html">Foreign Function Interface</a></li>
</ul>
* MIT/GNU Scheme FFI: (mit-scheme-ffi).
Foreign Function Interface
-* MIT/GNU Scheme IMAIL: (mit-scheme-imail).
- IMAP/MIME email reader
* MIT/GNU Scheme Reference: (mit-scheme-ref).
Reference Manual
* MIT/GNU Scheme SOS: (mit-scheme-sos).
# **** END BOILERPLATE ****
LIARC_BOOT_BUNDLES = compiler cref sf star-parser
-LIARC_BUNDLES = $(LIARC_BOOT_BUNDLES) edwin ffi imail sos ssp xml
+LIARC_BUNDLES = $(LIARC_BOOT_BUNDLES) ffi sos ssp xml
SUBDIRS = $(INSTALLED_SUBDIRS) 6001 rcs win32 xdoc
INSTALLED_SUBDIRS = microcode runtime $(LIARC_BUNDLES)
MIT_SCHEME_EXE = @MIT_SCHEME_EXE@
AUXDIR_NAME = @AUXDIR_NAME@
AUXDIR = @AUXDIR@
-EDDIR = $(AUXDIR)/edwin
default-target: @DEFAULT_TARGET@
all-native: lib/all.com
all-native: all-compiler
all-native: all-cref
-all-native: all-edwin
all-native: all-ffi
-all-native: all-imail
all-native: all-runtime
all-native: all-sf
all-native: all-sos
all-native: cross-target
@IF_CROSS@COMPILER_SETTINGS_CROSS = (set! compiler:cross-compiling? true)
-@IF_LIARC@COMPILER_SETTINGS_LIARC = (set! compiler:invoke-c-compiler? false)
TOOL_COMPILER_SETTINGS = \
$(COMPILER_SETTINGS_CROSS) \
tools/compiler.com:
$(MAKE) -f Makefile.tools clean && $(MAKE) -f Makefile.tools allclean
-# This target toolchain crud is a kludge until the whole system can be
-# cross-compiled. Currently only IMAIL can't be.
-TARGET_COMPILER_SETTINGS = \
- $(COMPILER_SETTINGS_LIARC)
-
TARGET_RUNTIME = ./microcode/scheme \
--library lib --band runtime.com --batch-mode
TARGET_COMPILER = $(TARGET_RUNTIME) \
TARGET_SYNTAXER = $(TARGET_RUNTIME) \
--eval '(load-option (quote CREF))' \
--eval '(load-option (quote SF))'
-TARGET_TOOLCHAIN = $(TARGET_RUNTIME) \
- --eval '(load-option (quote COMPILER))' \
- --eval '(load-option (quote CREF))' \
- --eval '(load-option (quote SF))' \
- --eval '(begin $(TARGET_COMPILER_SETTINGS))'
.PHONY: target-toolchain
target-toolchain: all-compiler
--fasl "$${FASL}"))
lib/compiler.com: all-compiler
-lib/compiler.com: all-edwin
lib/compiler.com: all-sf
lib/compiler.com: lib/runtime.com
lib/compiler.com: microcode/scheme
| ./microcode/scheme --batch-mode --library lib --band runtime.com
lib/all.com: all-compiler
-lib/all.com: all-edwin
lib/all.com: all-sf
lib/all.com: lib/runtime.com
lib/all.com: microcode/scheme
(echo '(begin' && \
echo ' (load-option (quote COMPILER))' && \
echo ' (load-option (quote SF))' && \
- echo ' (load-option (quote EDWIN))' && \
echo ' (disk-save "$@"))') \
| ./microcode/scheme --batch-mode --library lib --band runtime.com
### built compiler in the native case, but we want to avoid having to
### do that to encourage cross-compilation.
-# Edwin
-
-.PHONY: all-edwin
-all-edwin: compile-edwin
-@IF_LIARC@all-edwin: bundle-edwin
-
-.PHONY: bundle-edwin
-bundle-edwin: liarc-bundle-tools
-bundle-edwin: compile-edwin
-bundle-edwin: edwin/edwin.c
-bundle-edwin: edwin/edwin-unx.c
-bundle-edwin: edwin/edwin-w32.c
- (cd edwin && $(MAKE) compile-liarc-bundle)
-
-edwin/edwin.bld: syntax-edwin
-
-.PHONY: compile-edwin
-compile-edwin: toolchain
-compile-edwin: syntax-edwin
- (echo '(with-working-directory-pathname "edwin"' && \
- echo ' (lambda () (load "edwin.cbf")))') \
- | $(TOOL_TOOLCHAIN)
-
-.PHONY: syntax-edwin
-syntax-edwin: toolchain
-syntax-edwin: cref-edwin
- (echo '(with-working-directory-pathname "edwin"' && \
- echo ' (lambda () (load "edwin.sf")))') \
- | $(TOOL_TOOLCHAIN)
-
-.PHONY: cref-edwin
-cref-edwin: edwin/edwin-unx.pkd
-
-edwin/edwin-unx.pkd: toolchain
-edwin/edwin-unx.pkd: cref-runtime
-edwin/edwin-unx.pkd: cref-win32
-edwin/edwin-unx.pkd: cref-xml
-edwin/edwin-unx.pkd: edwin/edwin.pkg
- (echo '(with-working-directory-pathname "edwin"' && \
- echo ' (lambda ()' && \
- echo ' (cref/generate-trivial-constructor "edwin")))') \
- | $(TOOL_SYNTAXER)
-
-# XXX Kludgey bogus rules for liarc.
-edwin/edwin-w32.pkd: edwin/edwin-unx.pkd
-
# FFI
.PHONY: all-ffi
# cross-compilation host, transfer everything over, and then run `make'
# to do the rest, since the default target depends on cross-target.
# (Rsync should help iterating this process.)
-#
-# Anything that depends on running the target code should depend on
-# cross-target, and there should be a plan for obviating the need to
-# run the target code. Currently this is only IMAIL.
.PHONY: cross-host
cross-host: compile-compiler
cross-host: compile-cref
-cross-host: compile-edwin
cross-host: compile-ffi
-#cross-host: compile-imail
cross-host: compile-runtime
cross-host: compile-sf
cross-host: compile-sos
| (cd runtime && ../microcode/scheme --batch-mode --library ../lib \
--fasl make.bin)
-### Stuff that depends on running the code we just compiled, because it
-### uses Edwin macros. This is a kludge until we can fix macro phasing
-### and persuade the cross-compiler to load and run macros for the
-### target.
-
-# IMAIL
-
-.PHONY: all-imail
-all-imail: compile-imail
-@IF_LIARC@all-imail: bundle-imail
-
-.PHONY: bundle-imail
-bundle-imail: liarc-bundle-tools
-bundle-imail: compile-imail
-bundle-imail: imail/imail-unx.c
-bundle-imail: imail/imail-w32.c
- (cd imail && $(MAKE) compile-liarc-bundle)
-
-# Must write these rules explicitly because we use TARGET_COMPILER, not
-# TOOL_COMPILER.
-#
-# XXX These depend on imail/imail-unx.pkd intentionally because make
-# has no good way to express a rule that generates multiple files at
-# once.
-imail/imail-unx.c: imail/imail-unx.pkd
- echo '(cbf "imail/imail-unx.pkd")' | $(TARGET_COMPILER)
-imail/imail-w32.c: imail/imail-unx.pkd
- echo '(cbf "imail/imail-w32.pkd")' | $(TARGET_COMPILER)
-
-# XXX We enter lib/imail/ rather than imail/ so that liarc library
-# directory pathnames get resolved to builtin objects. This is a
-# kludge.
-
-.PHONY: compile-imail
-compile-imail: target-toolchain
-compile-imail: compile-edwin
-compile-imail: compile-runtime
-compile-imail: compile-sos
-compile-imail: compile-star-parser
-compile-imail: cref-imail
- (echo '(begin' && \
- echo ' (load-option (quote *PARSER))' && \
- echo ' (load-option (quote EDWIN))' && \
- echo ' (load-option (quote SOS))' && \
- echo ' (with-working-directory-pathname "lib/imail"' && \
- echo ' (lambda ()' && \
- echo ' (load "compile"))))') \
- | $(TARGET_TOOLCHAIN)
-
-.PHONY: cref-imail
-cref-imail: imail/imail-unx.pkd
-
-@IF_LIARC@IMAIL_CREF_PRELOAD = \
-@IF_LIARC@ echo '(load-option (quote SOS))' && \
-@IF_LIARC@ echo '(load-option (quote EDWIN))' && \
-@IF_LIARC@ echo '(load-option (quote *PARSER))' &&
-
-imail/imail-unx.pkd: target-toolchain
-imail/imail-unx.pkd: cref-edwin
-imail/imail-unx.pkd: cref-runtime
-imail/imail-unx.pkd: cref-sos
-imail/imail-unx.pkd: cref-star-parser
-@IF_LIARC@imail/imail-unx.pkd: all-edwin
-@IF_LIARC@imail/imail-unx.pkd: all-runtime
-@IF_LIARC@imail/imail-unx.pkd: all-sos
-@IF_LIARC@imail/imail-unx.pkd: all-star-parser
-imail/imail-unx.pkd: imail/imail.pkg
- (echo '(begin' && \
- $(IMAIL_CREF_PRELOAD) \
- echo ' (with-working-directory-pathname "lib/imail"' && \
- echo ' (lambda ()' && \
- echo ' (cref/generate-trivial-constructor "imail"))))') \
- | $(TARGET_SYNTAXER)
-
# **** Legacy serialized targets ****
all-svm: microcode/svm1-defns.h
install-standard: install-auxdir-top
etc/make-in-subdirs.sh install $(INSTALLED_SUBDIRS)
- $(mkinstalldirs) $(DESTDIR)$(EDDIR)
- $(INSTALL_DATA) $(top_srcdir)/etc/TUTORIAL $(DESTDIR)$(EDDIR)/.
install-auxdir-top:
$(mkinstalldirs) $(DESTDIR)$(AUXDIR)
* "cref" is a cross-reference program that also implements a
rudimentary module system.
-The editor subsystem consists of two directories:
-
-* "edwin" contains our Emacs-like editor written in Scheme.
-
-* "imail" contains an email-reading program for Edwin.
-
There are a few C/Unix FFI plugins:
* "gdbm" wraps libgdbm, the GNU dbm database routines, and provides a
* "mhash" wraps libmhash and provides replacements for the mhash-*
procedures in (runtime crypto).
+
+The editor subsystem consists of two directories:
+
+* "edwin" contains our Emacs-like editor written in Scheme and using
+ several plugins, e.g. gdbm, md5 and x11.
+
+* "imail" contains an email-reading program for Edwin.
\f
These are miscellaneous extras:
. etc/functions.sh
-INSTALLED_SUBDIRS="cref edwin ffi imail sf sos ssp star-parser xml"
+INSTALLED_SUBDIRS="cref ffi sf sos ssp star-parser xml"
OTHER_SUBDIRS="6001 compiler rcs runtime win32 xdoc microcode"
# lib
maybe_link lib/compiler ../compiler
maybe_link lib/cref ../cref
-maybe_link lib/edwin ../edwin
maybe_link lib/ffi ../ffi
-maybe_link lib/imail ../imail
maybe_link lib/runtime ../runtime
maybe_link lib/sf ../sf
maybe_link lib/sos ../sos
blowfish \
compiler \
cref \
- edwin \
ffi \
gdbm \
- imail \
mcrypt \
md5 \
mhash \
;; corresponding @deffn in TEXI.
(parameterize ((param:suppress-loading-message? #t))
- (load-option 'CREF))
+ (load-option 'cref)
+ (load-option 'regular-expression))
(define read-package-model)
(define pmodel/packages)
(define package/name)
6001/Makefile
compiler/Makefile
cref/Makefile
-edwin/Makefile
ffi/Makefile
-imail/Makefile
runtime/Makefile
sf/Makefile
sos/Makefile
--- /dev/null
+To find out what should go in this file, see "Information For
+Maintainers of GNU Software" (maintain.texi), the section called
+"Recording Changes".
+
+Matt Birkholz The conversion to a separate package.
+The MIT/GNU Scheme Team Everything.
--- /dev/null
+ GNU LIBRARY GENERAL PUBLIC LICENSE
+ Version 2, June 1991
+
+ Copyright (C) 1991 Free Software Foundation, Inc.
+ 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+ Everyone is permitted to copy and distribute verbatim copies
+ of this license document, but changing it is not allowed.
+
+[This is the first released version of the library GPL. It is
+ numbered 2 because it goes with version 2 of the ordinary GPL.]
+
+ Preamble
+
+ The licenses for most software are designed to take away your
+freedom to share and change it. By contrast, the GNU General Public
+Licenses are intended to guarantee your freedom to share and change
+free software--to make sure the software is free for all its users.
+
+ This license, the Library General Public License, applies to some
+specially designated Free Software Foundation software, and to any
+other libraries whose authors decide to use it. You can use it for
+your libraries, too.
+
+ When we speak of free software, we are referring to freedom, not
+price. Our General Public Licenses are designed to make sure that you
+have the freedom to distribute copies of free software (and charge for
+this service if you wish), that you receive source code or can get it
+if you want it, that you can change the software or use pieces of it
+in new free programs; and that you know you can do these things.
+
+ To protect your rights, we need to make restrictions that forbid
+anyone to deny you these rights or to ask you to surrender the rights.
+These restrictions translate to certain responsibilities for you if
+you distribute copies of the library, or if you modify it.
+
+ For example, if you distribute copies of the library, whether gratis
+or for a fee, you must give the recipients all the rights that we gave
+you. You must make sure that they, too, receive or can get the source
+code. If you link a program with the library, you must provide
+complete object files to the recipients so that they can relink them
+with the library, after making changes to the library and recompiling
+it. And you must show them these terms so they know their rights.
+
+ Our method of protecting your rights has two steps: (1) copyright
+the library, and (2) offer you this license which gives you legal
+permission to copy, distribute and/or modify the library.
+
+ Also, for each distributor's protection, we want to make certain
+that everyone understands that there is no warranty for this free
+library. If the library is modified by someone else and passed on, we
+want its recipients to know that what they have is not the original
+version, so that any problems introduced by others will not reflect on
+the original authors' reputations.
+\f
+ Finally, any free program is threatened constantly by software
+patents. We wish to avoid the danger that companies distributing free
+software will individually obtain patent licenses, thus in effect
+transforming the program into proprietary software. To prevent this,
+we have made it clear that any patent must be licensed for everyone's
+free use or not licensed at all.
+
+ Most GNU software, including some libraries, is covered by the ordinary
+GNU General Public License, which was designed for utility programs. This
+license, the GNU Library General Public License, applies to certain
+designated libraries. This license is quite different from the ordinary
+one; be sure to read it in full, and don't assume that anything in it is
+the same as in the ordinary license.
+
+ The reason we have a separate public license for some libraries is that
+they blur the distinction we usually make between modifying or adding to a
+program and simply using it. Linking a program with a library, without
+changing the library, is in some sense simply using the library, and is
+analogous to running a utility program or application program. However, in
+a textual and legal sense, the linked executable is a combined work, a
+derivative of the original library, and the ordinary General Public License
+treats it as such.
+
+ Because of this blurred distinction, using the ordinary General
+Public License for libraries did not effectively promote software
+sharing, because most developers did not use the libraries. We
+concluded that weaker conditions might promote sharing better.
+
+ However, unrestricted linking of non-free programs would deprive the
+users of those programs of all benefit from the free status of the
+libraries themselves. This Library General Public License is intended to
+permit developers of non-free programs to use free libraries, while
+preserving your freedom as a user of such programs to change the free
+libraries that are incorporated in them. (We have not seen how to achieve
+this as regards changes in header files, but we have achieved it as regards
+changes in the actual functions of the Library.) The hope is that this
+will lead to faster development of free libraries.
+
+ The precise terms and conditions for copying, distribution and
+modification follow. Pay close attention to the difference between a
+"work based on the library" and a "work that uses the library". The
+former contains code derived from the library, while the latter only
+works together with the library.
+
+ Note that it is possible for a library to be covered by the ordinary
+General Public License rather than by this special one.
+\f
+ GNU LIBRARY GENERAL PUBLIC LICENSE
+ TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
+
+ 0. This License Agreement applies to any software library which
+contains a notice placed by the copyright holder or other authorized
+party saying it may be distributed under the terms of this Library
+General Public License (also called "this License"). Each licensee is
+addressed as "you".
+
+ A "library" means a collection of software functions and/or data
+prepared so as to be conveniently linked with application programs
+(which use some of those functions and data) to form executables.
+
+ The "Library", below, refers to any such software library or work
+which has been distributed under these terms. A "work based on the
+Library" means either the Library or any derivative work under
+copyright law: that is to say, a work containing the Library or a
+portion of it, either verbatim or with modifications and/or translated
+straightforwardly into another language. (Hereinafter, translation is
+included without limitation in the term "modification".)
+
+ "Source code" for a work means the preferred form of the work for
+making modifications to it. For a library, complete source code means
+all the source code for all modules it contains, plus any associated
+interface definition files, plus the scripts used to control compilation
+and installation of the library.
+
+ Activities other than copying, distribution and modification are not
+covered by this License; they are outside its scope. The act of
+running a program using the Library is not restricted, and output from
+such a program is covered only if its contents constitute a work based
+on the Library (independent of the use of the Library in a tool for
+writing it). Whether that is true depends on what the Library does
+and what the program that uses the Library does.
+
+ 1. You may copy and distribute verbatim copies of the Library's
+complete source code as you receive it, in any medium, provided that
+you conspicuously and appropriately publish on each copy an
+appropriate copyright notice and disclaimer of warranty; keep intact
+all the notices that refer to this License and to the absence of any
+warranty; and distribute a copy of this License along with the
+Library.
+
+ You may charge a fee for the physical act of transferring a copy,
+and you may at your option offer warranty protection in exchange for a
+fee.
+\f
+ 2. You may modify your copy or copies of the Library or any portion
+of it, thus forming a work based on the Library, and copy and
+distribute such modifications or work under the terms of Section 1
+above, provided that you also meet all of these conditions:
+
+ a) The modified work must itself be a software library.
+
+ b) You must cause the files modified to carry prominent notices
+ stating that you changed the files and the date of any change.
+
+ c) You must cause the whole of the work to be licensed at no
+ charge to all third parties under the terms of this License.
+
+ d) If a facility in the modified Library refers to a function or a
+ table of data to be supplied by an application program that uses
+ the facility, other than as an argument passed when the facility
+ is invoked, then you must make a good faith effort to ensure that,
+ in the event an application does not supply such function or
+ table, the facility still operates, and performs whatever part of
+ its purpose remains meaningful.
+
+ (For example, a function in a library to compute square roots has
+ a purpose that is entirely well-defined independent of the
+ application. Therefore, Subsection 2d requires that any
+ application-supplied function or table used by this function must
+ be optional: if the application does not supply it, the square
+ root function must still compute square roots.)
+
+These requirements apply to the modified work as a whole. If
+identifiable sections of that work are not derived from the Library,
+and can be reasonably considered independent and separate works in
+themselves, then this License, and its terms, do not apply to those
+sections when you distribute them as separate works. But when you
+distribute the same sections as part of a whole which is a work based
+on the Library, the distribution of the whole must be on the terms of
+this License, whose permissions for other licensees extend to the
+entire whole, and thus to each and every part regardless of who wrote
+it.
+
+Thus, it is not the intent of this section to claim rights or contest
+your rights to work written entirely by you; rather, the intent is to
+exercise the right to control the distribution of derivative or
+collective works based on the Library.
+
+In addition, mere aggregation of another work not based on the Library
+with the Library (or with a work based on the Library) on a volume of
+a storage or distribution medium does not bring the other work under
+the scope of this License.
+
+ 3. You may opt to apply the terms of the ordinary GNU General Public
+License instead of this License to a given copy of the Library. To do
+this, you must alter all the notices that refer to this License, so
+that they refer to the ordinary GNU General Public License, version 2,
+instead of to this License. (If a newer version than version 2 of the
+ordinary GNU General Public License has appeared, then you can specify
+that version instead if you wish.) Do not make any other change in
+these notices.
+\f
+ Once this change is made in a given copy, it is irreversible for
+that copy, so the ordinary GNU General Public License applies to all
+subsequent copies and derivative works made from that copy.
+
+ This option is useful when you wish to copy part of the code of
+the Library into a program that is not a library.
+
+ 4. You may copy and distribute the Library (or a portion or
+derivative of it, under Section 2) in object code or executable form
+under the terms of Sections 1 and 2 above provided that you accompany
+it with the complete corresponding machine-readable source code, which
+must be distributed under the terms of Sections 1 and 2 above on a
+medium customarily used for software interchange.
+
+ If distribution of object code is made by offering access to copy
+from a designated place, then offering equivalent access to copy the
+source code from the same place satisfies the requirement to
+distribute the source code, even though third parties are not
+compelled to copy the source along with the object code.
+
+ 5. A program that contains no derivative of any portion of the
+Library, but is designed to work with the Library by being compiled or
+linked with it, is called a "work that uses the Library". Such a
+work, in isolation, is not a derivative work of the Library, and
+therefore falls outside the scope of this License.
+
+ However, linking a "work that uses the Library" with the Library
+creates an executable that is a derivative of the Library (because it
+contains portions of the Library), rather than a "work that uses the
+library". The executable is therefore covered by this License.
+Section 6 states terms for distribution of such executables.
+
+ When a "work that uses the Library" uses material from a header file
+that is part of the Library, the object code for the work may be a
+derivative work of the Library even though the source code is not.
+Whether this is true is especially significant if the work can be
+linked without the Library, or if the work is itself a library. The
+threshold for this to be true is not precisely defined by law.
+
+ If such an object file uses only numerical parameters, data
+structure layouts and accessors, and small macros and small inline
+functions (ten lines or less in length), then the use of the object
+file is unrestricted, regardless of whether it is legally a derivative
+work. (Executables containing this object code plus portions of the
+Library will still fall under Section 6.)
+
+ Otherwise, if the work is a derivative of the Library, you may
+distribute the object code for the work under the terms of Section 6.
+Any executables containing that work also fall under Section 6,
+whether or not they are linked directly with the Library itself.
+\f
+ 6. As an exception to the Sections above, you may also compile or
+link a "work that uses the Library" with the Library to produce a
+work containing portions of the Library, and distribute that work
+under terms of your choice, provided that the terms permit
+modification of the work for the customer's own use and reverse
+engineering for debugging such modifications.
+
+ You must give prominent notice with each copy of the work that the
+Library is used in it and that the Library and its use are covered by
+this License. You must supply a copy of this License. If the work
+during execution displays copyright notices, you must include the
+copyright notice for the Library among them, as well as a reference
+directing the user to the copy of this License. Also, you must do one
+of these things:
+
+ a) Accompany the work with the complete corresponding
+ machine-readable source code for the Library including whatever
+ changes were used in the work (which must be distributed under
+ Sections 1 and 2 above); and, if the work is an executable linked
+ with the Library, with the complete machine-readable "work that
+ uses the Library", as object code and/or source code, so that the
+ user can modify the Library and then relink to produce a modified
+ executable containing the modified Library. (It is understood
+ that the user who changes the contents of definitions files in the
+ Library will not necessarily be able to recompile the application
+ to use the modified definitions.)
+
+ b) Accompany the work with a written offer, valid for at
+ least three years, to give the same user the materials
+ specified in Subsection 6a, above, for a charge no more
+ than the cost of performing this distribution.
+
+ c) If distribution of the work is made by offering access to copy
+ from a designated place, offer equivalent access to copy the above
+ specified materials from the same place.
+
+ d) Verify that the user has already received a copy of these
+ materials or that you have already sent this user a copy.
+
+ For an executable, the required form of the "work that uses the
+Library" must include any data and utility programs needed for
+reproducing the executable from it. However, as a special exception,
+the source code distributed need not include anything that is normally
+distributed (in either source or binary form) with the major
+components (compiler, kernel, and so on) of the operating system on
+which the executable runs, unless that component itself accompanies
+the executable.
+
+ It may happen that this requirement contradicts the license
+restrictions of other proprietary libraries that do not normally
+accompany the operating system. Such a contradiction means you cannot
+use both them and the Library together in an executable that you
+distribute.
+\f
+ 7. You may place library facilities that are a work based on the
+Library side-by-side in a single library together with other library
+facilities not covered by this License, and distribute such a combined
+library, provided that the separate distribution of the work based on
+the Library and of the other library facilities is otherwise
+permitted, and provided that you do these two things:
+
+ a) Accompany the combined library with a copy of the same work
+ based on the Library, uncombined with any other library
+ facilities. This must be distributed under the terms of the
+ Sections above.
+
+ b) Give prominent notice with the combined library of the fact
+ that part of it is a work based on the Library, and explaining
+ where to find the accompanying uncombined form of the same work.
+
+ 8. You may not copy, modify, sublicense, link with, or distribute
+the Library except as expressly provided under this License. Any
+attempt otherwise to copy, modify, sublicense, link with, or
+distribute the Library is void, and will automatically terminate your
+rights under this License. However, parties who have received copies,
+or rights, from you under this License will not have their licenses
+terminated so long as such parties remain in full compliance.
+
+ 9. You are not required to accept this License, since you have not
+signed it. However, nothing else grants you permission to modify or
+distribute the Library or its derivative works. These actions are
+prohibited by law if you do not accept this License. Therefore, by
+modifying or distributing the Library (or any work based on the
+Library), you indicate your acceptance of this License to do so, and
+all its terms and conditions for copying, distributing or modifying
+the Library or works based on it.
+
+ 10. Each time you redistribute the Library (or any work based on the
+Library), the recipient automatically receives a license from the
+original licensor to copy, distribute, link with or modify the Library
+subject to these terms and conditions. You may not impose any further
+restrictions on the recipients' exercise of the rights granted herein.
+You are not responsible for enforcing compliance by third parties to
+this License.
+\f
+ 11. If, as a consequence of a court judgment or allegation of patent
+infringement or for any other reason (not limited to patent issues),
+conditions are imposed on you (whether by court order, agreement or
+otherwise) that contradict the conditions of this License, they do not
+excuse you from the conditions of this License. If you cannot
+distribute so as to satisfy simultaneously your obligations under this
+License and any other pertinent obligations, then as a consequence you
+may not distribute the Library at all. For example, if a patent
+license would not permit royalty-free redistribution of the Library by
+all those who receive copies directly or indirectly through you, then
+the only way you could satisfy both it and this License would be to
+refrain entirely from distribution of the Library.
+
+If any portion of this section is held invalid or unenforceable under any
+particular circumstance, the balance of the section is intended to apply,
+and the section as a whole is intended to apply in other circumstances.
+
+It is not the purpose of this section to induce you to infringe any
+patents or other property right claims or to contest validity of any
+such claims; this section has the sole purpose of protecting the
+integrity of the free software distribution system which is
+implemented by public license practices. Many people have made
+generous contributions to the wide range of software distributed
+through that system in reliance on consistent application of that
+system; it is up to the author/donor to decide if he or she is willing
+to distribute software through any other system and a licensee cannot
+impose that choice.
+
+This section is intended to make thoroughly clear what is believed to
+be a consequence of the rest of this License.
+
+ 12. If the distribution and/or use of the Library is restricted in
+certain countries either by patents or by copyrighted interfaces, the
+original copyright holder who places the Library under this License may add
+an explicit geographical distribution limitation excluding those countries,
+so that distribution is permitted only in or among countries not thus
+excluded. In such case, this License incorporates the limitation as if
+written in the body of this License.
+
+ 13. The Free Software Foundation may publish revised and/or new
+versions of the Library General Public License from time to time.
+Such new versions will be similar in spirit to the present version,
+but may differ in detail to address new problems or concerns.
+
+Each version is given a distinguishing version number. If the Library
+specifies a version number of this License which applies to it and
+"any later version", you have the option of following the terms and
+conditions either of that version or of any later version published by
+the Free Software Foundation. If the Library does not specify a
+license version number, you may choose any version ever published by
+the Free Software Foundation.
+\f
+ 14. If you wish to incorporate parts of the Library into other free
+programs whose distribution conditions are incompatible with these,
+write to the author to ask for permission. For software which is
+copyrighted by the Free Software Foundation, write to the Free
+Software Foundation; we sometimes make exceptions for this. Our
+decision will be guided by the two goals of preserving the free status
+of all derivatives of our free software and of promoting the sharing
+and reuse of software generally.
+
+ NO WARRANTY
+
+ 15. BECAUSE THE LIBRARY IS LICENSED FREE OF CHARGE, THERE IS NO
+WARRANTY FOR THE LIBRARY, TO THE EXTENT PERMITTED BY APPLICABLE LAW.
+EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR
+OTHER PARTIES PROVIDE THE LIBRARY "AS IS" WITHOUT WARRANTY OF ANY
+KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE
+IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE
+LIBRARY IS WITH YOU. SHOULD THE LIBRARY PROVE DEFECTIVE, YOU ASSUME
+THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
+
+ 16. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
+WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY
+AND/OR REDISTRIBUTE THE LIBRARY AS PERMITTED ABOVE, BE LIABLE TO YOU
+FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR
+CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE
+LIBRARY (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING
+RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A
+FAILURE OF THE LIBRARY TO OPERATE WITH ANY OTHER SOFTWARE), EVEN IF
+SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
+DAMAGES.
+
+ END OF TERMS AND CONDITIONS
+\f
+ How to Apply These Terms to Your New Libraries
+
+ If you develop a new library, and you want it to be of the greatest
+possible use to the public, we recommend making it free software that
+everyone can redistribute and change. You can do so by permitting
+redistribution under these terms (or, alternatively, under the terms of the
+ordinary General Public License).
+
+ To apply these terms, attach the following notices to the library. It is
+safest to attach them to the start of each source file to most effectively
+convey the exclusion of warranty; and each file should have at least the
+"copyright" line and a pointer to where the full notice is found.
+
+ <one line to give the library's name and a brief idea of what it does.>
+ Copyright (C) <year> <name of author>
+
+ This library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Library General Public
+ License as published by the Free Software Foundation; either
+ version 2 of the License, or (at your option) any later version.
+
+ This library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ Library General Public License for more details.
+
+ You should have received a copy of the GNU Library General Public
+ License along with this library; if not, write to the
+ Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+ Boston, MA 02111-1307 USA.
+
+Also add information on how to contact you by electronic and paper mail.
+
+You should also get your employer (if you work as a programmer) or your
+school, if any, to sign a "copyright disclaimer" for the library, if
+necessary. Here is a sample; alter the names:
+
+ Yoyodyne, Inc., hereby disclaims all copyright interest in the
+ library `Frob' (a library for tweaking knobs) written by James Random Hacker.
+
+ <signature of Ty Coon>, 1 April 1990
+ Ty Coon, President of Vice
+
+That's all there is to it!
--- /dev/null
+-*-Text-*-
+
+Please see the git commit log:
+
+$ git clone git://git.savannah.gnu.org/mit-scheme.git
+$ git remote add puck git://birchwood-abbey.net/~matt/mit-scheme.git
+$ git fetch puck Gtk
+$ git log puck/Gtk -- src/edwin/
+++ /dev/null
-EDDIR = $(AUXDIR)/edwin
-EDOPTS = debian-changelog eystep lisppaste manual midas nntp paredit pasmod \
- print pwedit pwparse snr sort techinfo telnet tximod verilog vhdl \
- webster
-
-install:
- rm -rf $(DESTDIR)$(EDDIR)
- $(mkinstalldirs) $(DESTDIR)$(EDDIR)
- $(INSTALL_DATA) *.pkd *.bci $(DESTDIR)$(EDDIR)/.
- @for F in $(EDOPTS); do \
- CMD="$(INSTALL_COM) $${F}.com $(DESTDIR)$(EDDIR)/.";\
- echo "$${CMD}"; eval "$${CMD}";\
- done
--- /dev/null
+## Process this file with automake to produce Makefile.in
+##
+## Copyright (C) 1986, 1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994,
+## 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005,
+## 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015, 2016
+## Massachusetts Institute of Technology
+##
+## This file is part of MIT/GNU Scheme.
+##
+## MIT/GNU Scheme is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; either version 2 of the License, or (at
+## your option) any later version.
+##
+## MIT/GNU Scheme is distributed in the hope that it will be useful, but
+## WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+## General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with MIT/GNU Scheme; if not, write to the Free Software
+## Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301,
+## USA.
+
+EXTRA_DIST = autogen.sh
+
+MIT_SCHEME_EXE = @MIT_SCHEME_EXE@
+scmlibdir = @MIT_SCHEME_LIBDIR@
+scmlib_subdir = $(scmlibdir)edwin
+
+sources =@MIT_SCHEME_SOURCES@
+binaries =@MIT_SCHEME_BINARIES@
+
+scmlib_sub_DATA = $(sources)
+scmlib_sub_DATA += $(binaries)
+scmlib_sub_DATA += rename.scm rename.bci rename.com
+scmlib_sub_DATA += loadef.scm edwin.bld
+scmlib_sub_DATA += make.scm edwin-@MIT_SCHEME_OS_SUFFIX@.pkd
+scmlib_sub_DATA += TUTORIAL
+
+# Set these to the defaults used by Scheme.
+infodir = $(datarootdir)/info
+htmldir = $(libdir)/mit-scheme-pucked/doc
+dvidir = $(libdir)/mit-scheme-pucked/doc
+pdfdir = $(libdir)/mit-scheme-pucked/doc
+
+include $(srcdir)/source-dependencies.am
+edwin.bld: stamp-scheme
+edwin-@MIT_SCHEME_OS_SUFFIX@.pkd: stamp-scheme
+stamp-scheme: $(sources) edwin.pkg
+ touch stamp-scheme
+ if ! ./compile.sh; then rm stamp-scheme; exit 1; fi
+
+CLEANFILES = *.bin *.ext *.com *.bci *.moc *.fni *.crf *.fre *.pkd
+
+ETAGS_ARGS = $(sources)
+TAGS_DEPENDENCIES = $(sources)
+
+EXTRA_DIST += $(sources) compile.sh edwin.sf edwin.cbf edwin.pkg
+
+install-data-hook:
+ echo '(update-optiondb "$(DESTDIR)$(scmlibdir)")' \
+ | $(MIT_SCHEME_EXE) --batch-mode
+
+uninstall-hook:
+ echo '(update-optiondb "$(DESTDIR)$(scmlibdir)")' \
+ | $(MIT_SCHEME_EXE) --batch-mode
+ [ -d "$(DESTDIR)$(scmlib_subdir)" ] \
+ && rmdir "$(DESTDIR)$(scmlib_subdir)"
--- /dev/null
+mit-scheme-edwin NEWS -- history of user-visible changes.
+
+Copyright (C) 1986, 1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994,
+ 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004,
+ 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014,
+ 2015, 2016 Massachusetts Institute of Technology
+
+This file is part of MIT/GNU Scheme.
+
+MIT/GNU Scheme is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License as
+published by the Free Software Foundation; either version 2 of the
+License, or (at your option) any later version.
+
+MIT/GNU Scheme is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with MIT/GNU Scheme; if not, write to the Free Software
+Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+02110-1301, USA.
+
+mit-scheme-edwin 3.116 - Matt Birkholz, 2016-05-21
+==================================================
+
+* Edwin is now a separately buildable and installable automake
+ package. It requires only MIT/GNU Scheme to build and operate, but
+ will display only on a terminal. To display in an X window, Edwin
+ needs the x11-screen option installed.
--- /dev/null
+#!/bin/sh
+
+set -e
+./sources.sh deps >source-dependencies.am
+autoreconf --force --install
--- /dev/null
+#!/bin/sh
+# -*-Scheme-*-
+#
+# Copyright (C) 1986, 1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994,
+# 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005,
+# 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015, 2016
+# Massachusetts Institute of Technology
+#
+# This file is part of MIT/GNU Scheme.
+#
+# MIT/GNU Scheme is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or (at
+# your option) any later version.
+#
+# MIT/GNU Scheme is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+# General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with MIT/GNU Scheme; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301,
+# USA.
+
+# Compile the Edwin option.
+
+set -e
+: ${MIT_SCHEME_EXE=mit-scheme}
+${MIT_SCHEME_EXE} --batch-mode <<\EOF
+
+(begin
+ (load "edwin.sf")
+ (load "edwin.cbf"))
+EOF
+SUFFIX=`echo "(display (microcode-id/operating-system-suffix))" \
+ | ${MIT_SCHEME_EXE} --batch-mode`
+REPORT=edwin-$SUFFIX.crf
+if [ -s "$REPORT" ]; then echo "$REPORT:1: error: not empty"; exit 1; fi
--- /dev/null
+dnl Process this file with autoconf to produce a configure script.
+
+AC_INIT([MIT/GNU Scheme Edwin],
+ [3.116],
+ [bug-mit-scheme@gnu.org],
+ [mit-scheme-edwin])
+AC_CONFIG_SRCDIR([edwin.pkg])
+
+AC_COPYRIGHT(
+[Copyright (C) 1986, 1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994,
+ 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005,
+ 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015, 2016
+ Massachusetts Institute of Technology
+
+This file is part of MIT/GNU Scheme.
+
+MIT/GNU Scheme is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2 of the License, or (at
+your option) any later version.
+
+MIT/GNU Scheme is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with MIT/GNU Scheme; if not, write to the Free Software
+Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301,
+USA.
+])
+
+AM_INIT_AUTOMAKE
+
+AC_PROG_INSTALL
+
+: ${MIT_SCHEME_EXE=mit-scheme}
+MIT_SCHEME_LIBDIR=`( echo "(display (->namestring" ;\
+ echo " (system-library-directory-pathname)))" ) \
+ | ${MIT_SCHEME_EXE} --batch-mode`
+MIT_SCHEME_OS_SUFFIX=`echo "(display (microcode-id/operating-system-suffix))" \
+ | ${MIT_SCHEME_EXE} --batch-mode`
+MIT_SCHEME_SOURCES=`./sources.sh scm`
+MIT_SCHEME_BINARIES=`./sources.sh com`
+
+AC_SUBST([MIT_SCHEME_SOURCES])
+AC_SUBST([MIT_SCHEME_BINARIES])
+AC_SUBST([MIT_SCHEME_EXE])
+AC_SUBST([MIT_SCHEME_LIBDIR])
+AC_SUBST([MIT_SCHEME_OS_SUFFIX])
+AC_CONFIG_FILES([Makefile])
+AC_OUTPUT
(load "decls")
-(cref/generate-constructors "edwin" 'ALL)
+(cref/generate-constructors "edwin")
(sf-conditionally "edwin.ldr")
\ No newline at end of file
--- /dev/null
+#!/bin/sh
+# -*-Scheme-*-
+#
+# Copyright (C) 1986, 1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994,
+# 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005,
+# 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015, 2016
+# Massachusetts Institute of Technology
+#
+# This file is part of MIT/GNU Scheme.
+#
+# MIT/GNU Scheme is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or (at
+# your option) any later version.
+#
+# MIT/GNU Scheme is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+# General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with MIT/GNU Scheme; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301,
+# USA.
+
+# Generate a list of all source files.
+
+set -e
+: ${MIT_SCHEME_EXE=mit-scheme}
+${MIT_SCHEME_EXE} --batch-mode -- $1 <<\EOF
+
+(let ((command (car (command-line))))
+ (parameterize ((param:suppress-loading-message? #t))
+ (load-option 'CREF))
+ (let ((cref (->environment '(cross-reference))))
+ (let ((read-package-model (access read-package-model cref))
+ (pmodel/packages (access pmodel/packages cref))
+ (package/files (access package/files cref))
+ (os-type microcode-id/operating-system)
+ (write (named-lambda (write . strings)
+ (for-each write-string strings))))
+ (define (write-line . strings)
+ (apply write strings) (newline))
+ (let ((pathnames
+ (cons (->pathname "rename")
+ (append-map package/files
+ (pmodel/packages
+ (read-package-model "edwin" os-type))))))
+ (cond ((string=? command "scm")
+ (for-each (lambda (name) (write " "name))
+ (sort (map (lambda (pathname)
+ (->namestring (pathname-new-type pathname "scm")))
+ pathnames)
+ string<?)))
+ ((string=? command "com")
+ (for-each
+ (lambda (name) (write " "name".bci "name".com"))
+ (sort (map ->namestring pathnames) string<?)))
+ ((string=? command "deps")
+ (for-each
+ (lambda (name)
+ (write-line name".bci: stamp-scheme")
+ (write-line name".com: stamp-scheme"))
+ (sort (map ->namestring pathnames) string<?)))
+ (else
+ (error "Unexpected command:" command)))))))
+EOF
run_cmd ./microcode/scheme --batch-mode --library lib --band runtime.com <<EOF
(begin
(load-option (quote compiler))
- (load-option (quote edwin))
(disk-save "lib/all.com"))
EOF
(with-working-directory-pathname "sos"
(lambda ()
(load "load")))
- (for-each compile-dir '("xml" "win32" "edwin" "imail" "ssp" "ffi")))
+ (for-each compile-dir '("xml" "win32" "ssp" "ffi")))
(define (compile-boot-dirs compile-dir)
(compile-cref compile-dir)
(define (c-compile)
(in-liarc
(lambda ()
- (compile-all-dirs c-compile-dir)
- (cbf-conditionally "edwin/edwin.bld"))))
+ (compile-all-dirs c-compile-dir))))
(define (in-liarc thunk)
(fluid-let ((compiler:invoke-c-compiler? #f)
run_cmd ln -s machines/"${MDIR}" compiler/machine
run_cmd ln -s machine/compiler.pkg compiler/.
-BUNDLES="6001 compiler cref edwin ffi imail sf sos ssp star-parser xdoc xml"
+BUNDLES="6001 compiler cref ffi sf sos ssp star-parser xdoc xml"
run_cmd ${HOST_SCHEME_EXE} --batch-mode --heap 4000 <<EOF
(begin
(lose))
(finish dir pathname))))))))
\f
-(define-load-option 'EDWIN
- (guarded-system-loader '(edwin) "edwin"))
-
(define-load-option 'COMPILER
(lambda () (load-option 'SF))
(guarded-system-loader '(compiler) "compiler"
(define-load-option 'FFI
(guarded-system-loader '(ffi) "ffi"))
-(define-load-option 'IMAIL
- (guarded-system-loader '(edwin imail) "imail"))
-
(define-load-option '*PARSER
(guarded-system-loader '(runtime *parser) "star-parser"))
(cons* (compiler-make-file)
"base/make"
names))
- ((string=? bundle "edwin")
- (cons* "make"
- "edwin"
- "rename"
- names))
(else names)))
string<?))))
;; corresponding @deffn in TEXI.
(parameterize ((param:suppress-loading-message? #t))
- (load-option 'CREF))
+ (load-option 'cref)
+ (load-option 'regular-expression))
(define read-package-model)
(define pmodel/packages)
(define package/name)
(begin
(parameterize ((param:suppress-loading-message? #t))
- (load-option 'CREF)
- (load-option 'GTK))
+ (load-option 'cref)
+ (load-option 'gtk)
+ (load-option 'edwin))
(if (name->package '(EDWIN SCREEN GTK-SCREEN))
(error "The (EDWIN SCREEN GTK-SCREEN) package already exists."))
;; corresponding @deffn in TEXI.
(parameterize ((param:suppress-loading-message? #t))
- (load-option 'CREF))
+ (load-option 'cref)
+ (load-option 'regular-expression))
(define read-package-model)
(define pmodel/packages)
(define package/name)
--- /dev/null
+To find out what should go in this file, see "Information For
+Maintainers of GNU Software" (maintain.texi), the section called
+"Recording Changes".
+
+Matt Birkholz Conversion to a separate package, an automake
+ option.
+
+IMAIL existed as an option for MIT/GNU Scheme long before it was
+distributed as a separate package. Contributors to the code:
+
+$ for D in src/imail/ v7/src/imail/; do \
+> git log --pretty=format:"%an <%ae>" --follow -- $D; echo; done \
+> | sort | uniq
+Chris Hanson <org/chris-hanson/cph>
+Joe Marshall <eval.apply@gmail.com>
+Joe Marshall <jmarshall@alum.mit.edu>
+Matt Birkholz <matt@birkholz.chandler.az.us>
+Matt Birkholz <puck@birchwood-abbey.net>
+Michael R. Blair <edu/mit/csail/zurich/ziggy>
+Taylor R Campbell <campbell@mumble.net>
+Taylor R. Campbell <net/mumble/campbell>
--- /dev/null
+ GNU LIBRARY GENERAL PUBLIC LICENSE
+ Version 2, June 1991
+
+ Copyright (C) 1991 Free Software Foundation, Inc.
+ 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+ Everyone is permitted to copy and distribute verbatim copies
+ of this license document, but changing it is not allowed.
+
+[This is the first released version of the library GPL. It is
+ numbered 2 because it goes with version 2 of the ordinary GPL.]
+
+ Preamble
+
+ The licenses for most software are designed to take away your
+freedom to share and change it. By contrast, the GNU General Public
+Licenses are intended to guarantee your freedom to share and change
+free software--to make sure the software is free for all its users.
+
+ This license, the Library General Public License, applies to some
+specially designated Free Software Foundation software, and to any
+other libraries whose authors decide to use it. You can use it for
+your libraries, too.
+
+ When we speak of free software, we are referring to freedom, not
+price. Our General Public Licenses are designed to make sure that you
+have the freedom to distribute copies of free software (and charge for
+this service if you wish), that you receive source code or can get it
+if you want it, that you can change the software or use pieces of it
+in new free programs; and that you know you can do these things.
+
+ To protect your rights, we need to make restrictions that forbid
+anyone to deny you these rights or to ask you to surrender the rights.
+These restrictions translate to certain responsibilities for you if
+you distribute copies of the library, or if you modify it.
+
+ For example, if you distribute copies of the library, whether gratis
+or for a fee, you must give the recipients all the rights that we gave
+you. You must make sure that they, too, receive or can get the source
+code. If you link a program with the library, you must provide
+complete object files to the recipients so that they can relink them
+with the library, after making changes to the library and recompiling
+it. And you must show them these terms so they know their rights.
+
+ Our method of protecting your rights has two steps: (1) copyright
+the library, and (2) offer you this license which gives you legal
+permission to copy, distribute and/or modify the library.
+
+ Also, for each distributor's protection, we want to make certain
+that everyone understands that there is no warranty for this free
+library. If the library is modified by someone else and passed on, we
+want its recipients to know that what they have is not the original
+version, so that any problems introduced by others will not reflect on
+the original authors' reputations.
+\f
+ Finally, any free program is threatened constantly by software
+patents. We wish to avoid the danger that companies distributing free
+software will individually obtain patent licenses, thus in effect
+transforming the program into proprietary software. To prevent this,
+we have made it clear that any patent must be licensed for everyone's
+free use or not licensed at all.
+
+ Most GNU software, including some libraries, is covered by the ordinary
+GNU General Public License, which was designed for utility programs. This
+license, the GNU Library General Public License, applies to certain
+designated libraries. This license is quite different from the ordinary
+one; be sure to read it in full, and don't assume that anything in it is
+the same as in the ordinary license.
+
+ The reason we have a separate public license for some libraries is that
+they blur the distinction we usually make between modifying or adding to a
+program and simply using it. Linking a program with a library, without
+changing the library, is in some sense simply using the library, and is
+analogous to running a utility program or application program. However, in
+a textual and legal sense, the linked executable is a combined work, a
+derivative of the original library, and the ordinary General Public License
+treats it as such.
+
+ Because of this blurred distinction, using the ordinary General
+Public License for libraries did not effectively promote software
+sharing, because most developers did not use the libraries. We
+concluded that weaker conditions might promote sharing better.
+
+ However, unrestricted linking of non-free programs would deprive the
+users of those programs of all benefit from the free status of the
+libraries themselves. This Library General Public License is intended to
+permit developers of non-free programs to use free libraries, while
+preserving your freedom as a user of such programs to change the free
+libraries that are incorporated in them. (We have not seen how to achieve
+this as regards changes in header files, but we have achieved it as regards
+changes in the actual functions of the Library.) The hope is that this
+will lead to faster development of free libraries.
+
+ The precise terms and conditions for copying, distribution and
+modification follow. Pay close attention to the difference between a
+"work based on the library" and a "work that uses the library". The
+former contains code derived from the library, while the latter only
+works together with the library.
+
+ Note that it is possible for a library to be covered by the ordinary
+General Public License rather than by this special one.
+\f
+ GNU LIBRARY GENERAL PUBLIC LICENSE
+ TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
+
+ 0. This License Agreement applies to any software library which
+contains a notice placed by the copyright holder or other authorized
+party saying it may be distributed under the terms of this Library
+General Public License (also called "this License"). Each licensee is
+addressed as "you".
+
+ A "library" means a collection of software functions and/or data
+prepared so as to be conveniently linked with application programs
+(which use some of those functions and data) to form executables.
+
+ The "Library", below, refers to any such software library or work
+which has been distributed under these terms. A "work based on the
+Library" means either the Library or any derivative work under
+copyright law: that is to say, a work containing the Library or a
+portion of it, either verbatim or with modifications and/or translated
+straightforwardly into another language. (Hereinafter, translation is
+included without limitation in the term "modification".)
+
+ "Source code" for a work means the preferred form of the work for
+making modifications to it. For a library, complete source code means
+all the source code for all modules it contains, plus any associated
+interface definition files, plus the scripts used to control compilation
+and installation of the library.
+
+ Activities other than copying, distribution and modification are not
+covered by this License; they are outside its scope. The act of
+running a program using the Library is not restricted, and output from
+such a program is covered only if its contents constitute a work based
+on the Library (independent of the use of the Library in a tool for
+writing it). Whether that is true depends on what the Library does
+and what the program that uses the Library does.
+
+ 1. You may copy and distribute verbatim copies of the Library's
+complete source code as you receive it, in any medium, provided that
+you conspicuously and appropriately publish on each copy an
+appropriate copyright notice and disclaimer of warranty; keep intact
+all the notices that refer to this License and to the absence of any
+warranty; and distribute a copy of this License along with the
+Library.
+
+ You may charge a fee for the physical act of transferring a copy,
+and you may at your option offer warranty protection in exchange for a
+fee.
+\f
+ 2. You may modify your copy or copies of the Library or any portion
+of it, thus forming a work based on the Library, and copy and
+distribute such modifications or work under the terms of Section 1
+above, provided that you also meet all of these conditions:
+
+ a) The modified work must itself be a software library.
+
+ b) You must cause the files modified to carry prominent notices
+ stating that you changed the files and the date of any change.
+
+ c) You must cause the whole of the work to be licensed at no
+ charge to all third parties under the terms of this License.
+
+ d) If a facility in the modified Library refers to a function or a
+ table of data to be supplied by an application program that uses
+ the facility, other than as an argument passed when the facility
+ is invoked, then you must make a good faith effort to ensure that,
+ in the event an application does not supply such function or
+ table, the facility still operates, and performs whatever part of
+ its purpose remains meaningful.
+
+ (For example, a function in a library to compute square roots has
+ a purpose that is entirely well-defined independent of the
+ application. Therefore, Subsection 2d requires that any
+ application-supplied function or table used by this function must
+ be optional: if the application does not supply it, the square
+ root function must still compute square roots.)
+
+These requirements apply to the modified work as a whole. If
+identifiable sections of that work are not derived from the Library,
+and can be reasonably considered independent and separate works in
+themselves, then this License, and its terms, do not apply to those
+sections when you distribute them as separate works. But when you
+distribute the same sections as part of a whole which is a work based
+on the Library, the distribution of the whole must be on the terms of
+this License, whose permissions for other licensees extend to the
+entire whole, and thus to each and every part regardless of who wrote
+it.
+
+Thus, it is not the intent of this section to claim rights or contest
+your rights to work written entirely by you; rather, the intent is to
+exercise the right to control the distribution of derivative or
+collective works based on the Library.
+
+In addition, mere aggregation of another work not based on the Library
+with the Library (or with a work based on the Library) on a volume of
+a storage or distribution medium does not bring the other work under
+the scope of this License.
+
+ 3. You may opt to apply the terms of the ordinary GNU General Public
+License instead of this License to a given copy of the Library. To do
+this, you must alter all the notices that refer to this License, so
+that they refer to the ordinary GNU General Public License, version 2,
+instead of to this License. (If a newer version than version 2 of the
+ordinary GNU General Public License has appeared, then you can specify
+that version instead if you wish.) Do not make any other change in
+these notices.
+\f
+ Once this change is made in a given copy, it is irreversible for
+that copy, so the ordinary GNU General Public License applies to all
+subsequent copies and derivative works made from that copy.
+
+ This option is useful when you wish to copy part of the code of
+the Library into a program that is not a library.
+
+ 4. You may copy and distribute the Library (or a portion or
+derivative of it, under Section 2) in object code or executable form
+under the terms of Sections 1 and 2 above provided that you accompany
+it with the complete corresponding machine-readable source code, which
+must be distributed under the terms of Sections 1 and 2 above on a
+medium customarily used for software interchange.
+
+ If distribution of object code is made by offering access to copy
+from a designated place, then offering equivalent access to copy the
+source code from the same place satisfies the requirement to
+distribute the source code, even though third parties are not
+compelled to copy the source along with the object code.
+
+ 5. A program that contains no derivative of any portion of the
+Library, but is designed to work with the Library by being compiled or
+linked with it, is called a "work that uses the Library". Such a
+work, in isolation, is not a derivative work of the Library, and
+therefore falls outside the scope of this License.
+
+ However, linking a "work that uses the Library" with the Library
+creates an executable that is a derivative of the Library (because it
+contains portions of the Library), rather than a "work that uses the
+library". The executable is therefore covered by this License.
+Section 6 states terms for distribution of such executables.
+
+ When a "work that uses the Library" uses material from a header file
+that is part of the Library, the object code for the work may be a
+derivative work of the Library even though the source code is not.
+Whether this is true is especially significant if the work can be
+linked without the Library, or if the work is itself a library. The
+threshold for this to be true is not precisely defined by law.
+
+ If such an object file uses only numerical parameters, data
+structure layouts and accessors, and small macros and small inline
+functions (ten lines or less in length), then the use of the object
+file is unrestricted, regardless of whether it is legally a derivative
+work. (Executables containing this object code plus portions of the
+Library will still fall under Section 6.)
+
+ Otherwise, if the work is a derivative of the Library, you may
+distribute the object code for the work under the terms of Section 6.
+Any executables containing that work also fall under Section 6,
+whether or not they are linked directly with the Library itself.
+\f
+ 6. As an exception to the Sections above, you may also compile or
+link a "work that uses the Library" with the Library to produce a
+work containing portions of the Library, and distribute that work
+under terms of your choice, provided that the terms permit
+modification of the work for the customer's own use and reverse
+engineering for debugging such modifications.
+
+ You must give prominent notice with each copy of the work that the
+Library is used in it and that the Library and its use are covered by
+this License. You must supply a copy of this License. If the work
+during execution displays copyright notices, you must include the
+copyright notice for the Library among them, as well as a reference
+directing the user to the copy of this License. Also, you must do one
+of these things:
+
+ a) Accompany the work with the complete corresponding
+ machine-readable source code for the Library including whatever
+ changes were used in the work (which must be distributed under
+ Sections 1 and 2 above); and, if the work is an executable linked
+ with the Library, with the complete machine-readable "work that
+ uses the Library", as object code and/or source code, so that the
+ user can modify the Library and then relink to produce a modified
+ executable containing the modified Library. (It is understood
+ that the user who changes the contents of definitions files in the
+ Library will not necessarily be able to recompile the application
+ to use the modified definitions.)
+
+ b) Accompany the work with a written offer, valid for at
+ least three years, to give the same user the materials
+ specified in Subsection 6a, above, for a charge no more
+ than the cost of performing this distribution.
+
+ c) If distribution of the work is made by offering access to copy
+ from a designated place, offer equivalent access to copy the above
+ specified materials from the same place.
+
+ d) Verify that the user has already received a copy of these
+ materials or that you have already sent this user a copy.
+
+ For an executable, the required form of the "work that uses the
+Library" must include any data and utility programs needed for
+reproducing the executable from it. However, as a special exception,
+the source code distributed need not include anything that is normally
+distributed (in either source or binary form) with the major
+components (compiler, kernel, and so on) of the operating system on
+which the executable runs, unless that component itself accompanies
+the executable.
+
+ It may happen that this requirement contradicts the license
+restrictions of other proprietary libraries that do not normally
+accompany the operating system. Such a contradiction means you cannot
+use both them and the Library together in an executable that you
+distribute.
+\f
+ 7. You may place library facilities that are a work based on the
+Library side-by-side in a single library together with other library
+facilities not covered by this License, and distribute such a combined
+library, provided that the separate distribution of the work based on
+the Library and of the other library facilities is otherwise
+permitted, and provided that you do these two things:
+
+ a) Accompany the combined library with a copy of the same work
+ based on the Library, uncombined with any other library
+ facilities. This must be distributed under the terms of the
+ Sections above.
+
+ b) Give prominent notice with the combined library of the fact
+ that part of it is a work based on the Library, and explaining
+ where to find the accompanying uncombined form of the same work.
+
+ 8. You may not copy, modify, sublicense, link with, or distribute
+the Library except as expressly provided under this License. Any
+attempt otherwise to copy, modify, sublicense, link with, or
+distribute the Library is void, and will automatically terminate your
+rights under this License. However, parties who have received copies,
+or rights, from you under this License will not have their licenses
+terminated so long as such parties remain in full compliance.
+
+ 9. You are not required to accept this License, since you have not
+signed it. However, nothing else grants you permission to modify or
+distribute the Library or its derivative works. These actions are
+prohibited by law if you do not accept this License. Therefore, by
+modifying or distributing the Library (or any work based on the
+Library), you indicate your acceptance of this License to do so, and
+all its terms and conditions for copying, distributing or modifying
+the Library or works based on it.
+
+ 10. Each time you redistribute the Library (or any work based on the
+Library), the recipient automatically receives a license from the
+original licensor to copy, distribute, link with or modify the Library
+subject to these terms and conditions. You may not impose any further
+restrictions on the recipients' exercise of the rights granted herein.
+You are not responsible for enforcing compliance by third parties to
+this License.
+\f
+ 11. If, as a consequence of a court judgment or allegation of patent
+infringement or for any other reason (not limited to patent issues),
+conditions are imposed on you (whether by court order, agreement or
+otherwise) that contradict the conditions of this License, they do not
+excuse you from the conditions of this License. If you cannot
+distribute so as to satisfy simultaneously your obligations under this
+License and any other pertinent obligations, then as a consequence you
+may not distribute the Library at all. For example, if a patent
+license would not permit royalty-free redistribution of the Library by
+all those who receive copies directly or indirectly through you, then
+the only way you could satisfy both it and this License would be to
+refrain entirely from distribution of the Library.
+
+If any portion of this section is held invalid or unenforceable under any
+particular circumstance, the balance of the section is intended to apply,
+and the section as a whole is intended to apply in other circumstances.
+
+It is not the purpose of this section to induce you to infringe any
+patents or other property right claims or to contest validity of any
+such claims; this section has the sole purpose of protecting the
+integrity of the free software distribution system which is
+implemented by public license practices. Many people have made
+generous contributions to the wide range of software distributed
+through that system in reliance on consistent application of that
+system; it is up to the author/donor to decide if he or she is willing
+to distribute software through any other system and a licensee cannot
+impose that choice.
+
+This section is intended to make thoroughly clear what is believed to
+be a consequence of the rest of this License.
+
+ 12. If the distribution and/or use of the Library is restricted in
+certain countries either by patents or by copyrighted interfaces, the
+original copyright holder who places the Library under this License may add
+an explicit geographical distribution limitation excluding those countries,
+so that distribution is permitted only in or among countries not thus
+excluded. In such case, this License incorporates the limitation as if
+written in the body of this License.
+
+ 13. The Free Software Foundation may publish revised and/or new
+versions of the Library General Public License from time to time.
+Such new versions will be similar in spirit to the present version,
+but may differ in detail to address new problems or concerns.
+
+Each version is given a distinguishing version number. If the Library
+specifies a version number of this License which applies to it and
+"any later version", you have the option of following the terms and
+conditions either of that version or of any later version published by
+the Free Software Foundation. If the Library does not specify a
+license version number, you may choose any version ever published by
+the Free Software Foundation.
+\f
+ 14. If you wish to incorporate parts of the Library into other free
+programs whose distribution conditions are incompatible with these,
+write to the author to ask for permission. For software which is
+copyrighted by the Free Software Foundation, write to the Free
+Software Foundation; we sometimes make exceptions for this. Our
+decision will be guided by the two goals of preserving the free status
+of all derivatives of our free software and of promoting the sharing
+and reuse of software generally.
+
+ NO WARRANTY
+
+ 15. BECAUSE THE LIBRARY IS LICENSED FREE OF CHARGE, THERE IS NO
+WARRANTY FOR THE LIBRARY, TO THE EXTENT PERMITTED BY APPLICABLE LAW.
+EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR
+OTHER PARTIES PROVIDE THE LIBRARY "AS IS" WITHOUT WARRANTY OF ANY
+KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE
+IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE
+LIBRARY IS WITH YOU. SHOULD THE LIBRARY PROVE DEFECTIVE, YOU ASSUME
+THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
+
+ 16. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
+WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY
+AND/OR REDISTRIBUTE THE LIBRARY AS PERMITTED ABOVE, BE LIABLE TO YOU
+FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR
+CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE
+LIBRARY (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING
+RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A
+FAILURE OF THE LIBRARY TO OPERATE WITH ANY OTHER SOFTWARE), EVEN IF
+SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
+DAMAGES.
+
+ END OF TERMS AND CONDITIONS
+\f
+ How to Apply These Terms to Your New Libraries
+
+ If you develop a new library, and you want it to be of the greatest
+possible use to the public, we recommend making it free software that
+everyone can redistribute and change. You can do so by permitting
+redistribution under these terms (or, alternatively, under the terms of the
+ordinary General Public License).
+
+ To apply these terms, attach the following notices to the library. It is
+safest to attach them to the start of each source file to most effectively
+convey the exclusion of warranty; and each file should have at least the
+"copyright" line and a pointer to where the full notice is found.
+
+ <one line to give the library's name and a brief idea of what it does.>
+ Copyright (C) <year> <name of author>
+
+ This library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Library General Public
+ License as published by the Free Software Foundation; either
+ version 2 of the License, or (at your option) any later version.
+
+ This library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ Library General Public License for more details.
+
+ You should have received a copy of the GNU Library General Public
+ License along with this library; if not, write to the
+ Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+ Boston, MA 02111-1307 USA.
+
+Also add information on how to contact you by electronic and paper mail.
+
+You should also get your employer (if you work as a programmer) or your
+school, if any, to sign a "copyright disclaimer" for the library, if
+necessary. Here is a sample; alter the names:
+
+ Yoyodyne, Inc., hereby disclaims all copyright interest in the
+ library `Frob' (a library for tweaking knobs) written by James Random Hacker.
+
+ <signature of Ty Coon>, 1 April 1990
+ Ty Coon, President of Vice
+
+That's all there is to it!
--- /dev/null
+-*-Text-*-
+
+Please see the git commit log:
+
+$ git clone git://git.savannah.gnu.org/mit-scheme.git
+$ git log origin/master -- src/imail/
+++ /dev/null
-IMAIL_DIR = $(AUXDIR)/imail
-
-install:
- $(mkinstalldirs) $(DESTDIR)$(IMAIL_DIR)
- $(INSTALL_COM) *.com $(DESTDIR)$(IMAIL_DIR)/.
- $(INSTALL_DATA) *.pkd *.bci $(DESTDIR)$(IMAIL_DIR)/.
- $(INSTALL_DATA) $(srcdir)/load.scm $(DESTDIR)$(IMAIL_DIR)/.
--- /dev/null
+## Process this file with automake to produce Makefile.in
+##
+## Copyright (C) 1986, 1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994,
+## 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005,
+## 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015, 2016
+## Massachusetts Institute of Technology
+##
+## This file is part of the IMail option for MIT/GNU Scheme.
+##
+## IMail is free software; you can redistribute it and/or modify it
+## under the terms of the GNU General Public License as published by
+## the Free Software Foundation; either version 2 of the License, or
+## (at your option) any later version.
+##
+## IMail is distributed in the hope that it will be useful, but
+## WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+## General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with IMail; if not, write to the Free Software Foundation,
+## Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
+
+EXTRA_DIST = autogen.sh
+
+MIT_SCHEME_EXE = @MIT_SCHEME_EXE@
+scmlibdir = @MIT_SCHEME_LIBDIR@
+scmlib_subdir = $(scmlibdir)imail
+
+sources = imail-browser.scm imail-core.scm imail-file.scm imail-imap.scm
+sources += imail-mime.scm imail-rmail.scm imail-summary.scm imail-top.scm
+sources += imail-umail.scm imail-util.scm imap-response.scm imap-syntax.scm
+
+binaries = imail-browser.bci imail-browser.com
+binaries += imail-core.bci imail-core.com
+binaries += imail-file.bci imail-file.com
+binaries += imail-imap.bci imail-imap.com
+binaries += imail-mime.bci imail-mime.com
+binaries += imail-rmail.bci imail-rmail.com
+binaries += imail-summary.bci imail-summary.com
+binaries += imail-top.bci imail-top.com
+binaries += imail-umail.bci imail-umail.com
+binaries += imail-util.bci imail-util.com
+binaries += imap-response.bci imap-response.com
+binaries += imap-syntax.bci imap-syntax.com
+
+scmlib_sub_DATA = $(sources)
+scmlib_sub_DATA += $(binaries)
+scmlib_sub_DATA += load.scm imail-@MIT_SCHEME_OS_SUFFIX@.pkd
+
+# Set these to the defaults used by Scheme.
+infodir = $(datarootdir)/info
+htmldir = $(libdir)/mit-scheme-pucked/doc
+dvidir = $(libdir)/mit-scheme-pucked/doc
+pdfdir = $(libdir)/mit-scheme-pucked/doc
+
+imail-browser.bci: stamp-scheme
+imail-browser.com: stamp-scheme
+imail-core.bci: stamp-scheme
+imail-core.com: stamp-scheme
+imail-file.bci: stamp-scheme
+imail-file.com: stamp-scheme
+imail-imap.bci: stamp-scheme
+imail-imap.com: stamp-scheme
+imail-mime.bci: stamp-scheme
+imail-mime.com: stamp-scheme
+imail-rmail.bci: stamp-scheme
+imail-rmail.com: stamp-scheme
+imail-summary.bci: stamp-scheme
+imail-summary.com: stamp-scheme
+imail-top.bci: stamp-scheme
+imail-top.com: stamp-scheme
+imail-umail.bci: stamp-scheme
+imail-umail.com: stamp-scheme
+imail-util.bci: stamp-scheme
+imail-util.com: stamp-scheme
+imap-response.bci: stamp-scheme
+imap-response.com: stamp-scheme
+imap-syntax.bci: stamp-scheme
+imap-syntax.com: stamp-scheme
+imail-@MIT_SCHEME_OS_SUFFIX@.pkd: stamp-scheme
+stamp-scheme: $(sources) imail.pkg
+ touch stamp-scheme
+ if ! ./compile.sh; then rm stamp-scheme; exit 1; fi
+
+CLEANFILES = *.bin *.ext *.com *.bci *.moc *.fni *.crf *.fre *.pkd
+
+#TESTS = imail-check.sh
+
+ETAGS_ARGS = $(sources)
+TAGS_DEPENDENCIES = $(sources)
+
+EXTRA_DIST += $(sources) compile.sh imail.pkg
+EXTRA_DIST += load.scm
+
+install-data-hook:
+ echo '(update-optiondb "$(DESTDIR)$(scmlibdir)")' \
+ | $(MIT_SCHEME_EXE) --batch-mode
+
+uninstall-hook:
+ echo '(update-optiondb "$(DESTDIR)$(scmlibdir)")' \
+ | $(MIT_SCHEME_EXE) --batch-mode
+ [ -d "$(DESTDIR)$(scmlib_subdir)" ] \
+ && rmdir "$(DESTDIR)$(scmlib_subdir)"
--- /dev/null
+mit-scheme-edwin NEWS -- history of user-visible changes.
+
+Copyright (C) 1986, 1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994,
+ 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004,
+ 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014,
+ 2015, 2016 Massachusetts Institute of Technology
+
+This file is part of MIT/GNU Scheme.
+
+MIT/GNU Scheme is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License as
+published by the Free Software Foundation; either version 2 of the
+License, or (at your option) any later version.
+
+MIT/GNU Scheme is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with MIT/GNU Scheme; if not, write to the Free Software
+Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+02110-1301, USA.
+
+mit-scheme-edwin 3.116 - Matt Birkholz, 2016-02-19
+==================================================
+
+* Use automake; Edwin is no longer a core option.
--- /dev/null
+Notes on the Edwin sources:
+
+If you want to add a new file to the source tree, you need to
+modify the following three files:
+
+ decls.scm
+ ed-ffi.scm
+ edwin.pkg
+
+If the file should be loaded into the default edwin band, you must also
+edit the file:
+
+ edwin.ldr
+
+If the file is to be autoloaded, you must edit the file:
+
+ loadef.scm
+
+So, in either case, you have to change four files in
+"/scheme/v8/src/edwin". Of course, you also have to put a copy of
+your file in "/scheme/v8/src/edwin", too, and you have to put a link
+to the new file in "/scheme/v7/linux/edwin".
--- /dev/null
+#!/bin/sh
+
+set -e
+autoreconf --force --install
"imail-util"
"imap-response"
"imap-syntax"))
- (cref/generate-constructors "imail" 'ALL)))
\ No newline at end of file
+ (cref/generate-constructors "imail")))
\ No newline at end of file
--- /dev/null
+#!/bin/sh
+# -*-Scheme-*-
+#
+# Copyright (C) 1986, 1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994,
+# 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005,
+# 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015, 2016
+# Massachusetts Institute of Technology
+#
+# This file is part of MIT/GNU Scheme.
+#
+# MIT/GNU Scheme is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or (at
+# your option) any later version.
+#
+# MIT/GNU Scheme is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+# General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with MIT/GNU Scheme; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301,
+# USA.
+
+# Compile the IMail option.
+
+set -e
+: ${MIT_SCHEME_EXE=mit-scheme}
+${MIT_SCHEME_EXE} --batch-mode <<\EOF
+(begin
+
+ (parameterize ((param:suppress-loading-message? #t))
+ (load-option 'EDWIN))
+
+ (load "compile.scm")
+ )
+EOF
+SUFFIX=`echo "(display (microcode-id/operating-system-suffix))" \
+ | ${MIT_SCHEME_EXE} --batch-mode`
+REPORT=imail-$SUFFIX.crf
+if [ -s "$REPORT" ]; then echo "$REPORT:1: error: not empty"; exit 1; fi
--- /dev/null
+dnl Process this file with autoconf to produce a configure script.
+
+AC_INIT([MIT/GNU Scheme Edwin IMail],
+ [1.21],
+ [bug-mit-scheme@gnu.org],
+ [mit-scheme-imail])
+AC_CONFIG_SRCDIR([imail.pkg])
+
+AC_COPYRIGHT(
+[Copyright (C) 1986, 1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994,
+ 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005,
+ 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015, 2016
+ Massachusetts Institute of Technology
+
+This file is part of the IMail option for MIT/GNU Scheme.
+
+IMail is free software; you can redistribute it and/or modify it under
+the terms of the GNU General Public License as published by the Free
+Software Foundation; either version 2 of the License, or (at your
+option) any later version.
+
+IMail is distributed in the hope that it will be useful, but WITHOUT
+ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
+for more details.
+
+You should have received a copy of the GNU General Public License
+along with IMail; if not, write to the Free Software Foundation, Inc.,
+51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA. ])
+
+AM_INIT_AUTOMAKE
+
+AC_PROG_INSTALL
+
+: ${MIT_SCHEME_EXE=mit-scheme}
+MIT_SCHEME_LIBDIR=`( echo "(display (->namestring" ;\
+ echo " (system-library-directory-pathname)))" ) \
+ | ${MIT_SCHEME_EXE} --batch-mode`
+MIT_SCHEME_OS_SUFFIX=`echo "(display (microcode-id/operating-system-suffix))" \
+ | ${MIT_SCHEME_EXE} --batch-mode`
+
+AC_SUBST([MIT_SCHEME_EXE])
+AC_SUBST([MIT_SCHEME_LIBDIR])
+AC_SUBST([MIT_SCHEME_OS_SUFFIX])
+AC_CONFIG_FILES([Makefile])
+AC_OUTPUT
+++ /dev/null
-#!/bin/sh
-cpx -c ~/new/imail $scm/.
2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015, 2016
Massachusetts Institute of Technology
-This file is part of MIT/GNU Scheme.
+This file is part of the IMail option for MIT/GNU Scheme.
-MIT/GNU Scheme is free software; you can redistribute it and/or modify
-it under the terms of the GNU General Public License as published by
-the Free Software Foundation; either version 2 of the License, or (at
-your option) any later version.
+IMail is free software; you can redistribute it and/or modify it under
+the terms of the GNU General Public License as published by the Free
+Software Foundation; either version 2 of the License, or (at your
+option) any later version.
-MIT/GNU Scheme is distributed in the hope that it will be useful, but
-WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
-General Public License for more details.
+IMail is distributed in the hope that it will be useful, but WITHOUT
+ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
+for more details.
You should have received a copy of the GNU General Public License
-along with MIT/GNU Scheme; if not, write to the Free Software
-Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301,
-USA.
+along with IMail; if not, write to the Free Software Foundation, Inc.,
+51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
|#
#!/bin/sh
+# -*-Scheme-*-
#
# Test the MCRYPT option.
set -e
${MIT_SCHEME_EXE} --prepend-library . <<\EOF
-(load-option 'MCRYPT)
-(load "mcrypt-check" (->environment '(mcrypt)))
+(begin
+ (load-option 'synchronous-subprocess)
+ (load-option 'mcrypt)
+ (load "mcrypt-check" (->environment '(mcrypt))))
EOF
;; corresponding @deffn in TEXI.
(parameterize ((param:suppress-loading-message? #t))
- (load-option 'CREF))
+ (load-option 'cref)
+ (load-option 'regular-expression))
(define read-package-model)
(define pmodel/packages)
(define package/name)
;;; Build support, autoloaded
(define (generate-shim library #!optional prefix)
- (load-ffi-quietly)
+ (load-option-quietly 'ffi)
((environment-lookup (->environment '(ffi)) 'c-generate) library prefix))
(define (update-optiondb directory)
- (load-ffi-quietly)
+ (load-option-quietly 'ffi)
((environment-lookup (->environment '(ffi)) 'update-optiondb) directory))
(define (update-html-index directory)
- (load-ffi-quietly)
- ((environment-lookup (->environment '(ffi)) 'update-html-index) directory))
+ (load-option-quietly 'ffi)
+ (load-option-quietly 'regular-expression)
+ ((environment-lookup (->environment '(ffi)) 'update-html-index)
+ directory))
-(define (load-ffi-quietly)
- (if (not (name->package '(FFI)))
+(define (load-option-quietly name)
+ (if (not (name->package (list name)))
(let ((kernel
(lambda ()
(parameterize* (list (cons param:suppress-loading-message? #t))
(lambda ()
- (load-option 'FFI))))))
+ (load-option name))))))
(if (nearest-cmdl/batch-mode?)
(kernel)
- (with-notification (lambda (port)
- (write-string "Loading FFI option" port))
- kernel)))))
+ (with-notification
+ (lambda (port)
+ (write-string "Loading " port)
+ (write-string (string-upcase (symbol-name name)) port)
+ (write-string " option" port))
+ kernel)))))
\f
(define calloutback-stack '())
environment
repl)))))
"Evaluates the argument expressions as if in the REPL.")
+ (simple-command-line-parser "edit"
+ (named-lambda (command-line-edit)
+ (with-notification (lambda (port) (display "Loading Edwin" port))
+ (lambda ()
+ (parameterize* (list (cons param:suppress-loading-message? #t))
+ (lambda ()
+ (load-option 'EDWIN)
+ (if (let ((DISPLAY (get-environment-variable "DISPLAY")))
+ (and (string? DISPLAY)
+ (not (string-null? DISPLAY))))
+ (ignore-errors (lambda () (load-option 'x11-screen))))))))
+ ((environment-lookup #f 'edit)))
+ "Causes Edwin to start immediately after Scheme.")
(simple-command-line-parser "help" show-command-line-options #f)
(simple-command-line-parser "version" (lambda () (%exit 0)) #f)
(set-command-line-parser!
;;;; Build and test the test plugin.
+(load-option 'synchronous-subprocess)
(with-working-directory-pathname (directory-pathname (current-load-pathname))
(lambda ()
(let ((port (notification-output-port)))
(declare (usual-integrations))
\f
+(load-option 'mime-codec)
+
(define (test-encoder n-packets packet-length text? filename
initialize finalize update)
(call-with-output-file filename
(declare (usual-integrations))
\f
+(load-option 'subprocess)
+
(define (shell-subprocess command)
(start-pipe-subprocess "/bin/sh" `#("/bin/sh" "-c" ,command) '#()))